function SilHUD2:PopulateOptions()
	self.sh2debug = 	{
							name = "Debug Mode",
							type = "toggle",
							desc = "Toggle debug mode",
							get = function() return SilHUD2Settings.toggles.sh2debug end,
							set = function() SilHUD2Settings.toggles.sh2debug = not SilHUD2Settings.toggles.sh2debug end,
							map = {	[false] = "Off", [true] = "On"	}
						};
	self.sh2options = 	{
						type = "group",
						name = "SilHUD2 Settings",
						args = 	{	
									
									alpha =			{
														order =  2,
														name = "Transparency",
														type = "group",
														desc = "Alter HUD transparency settings",
														args = {
																	contexttoggle = {
																						order = 1,
																						name = "Context-Sensitive Fade",
																						type = "toggle",
																						desc = "Turns context-sensitive fade on and off",
																						get = function() return SilHUD2Settings.toggles.contextOn end,
																						set = 	function()
																									SilHUD2Settings.toggles.contextOn = not SilHUD2Settings.toggles.contextOn;
																									SilHUD2:Transparency();
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						map = { [false] = "Off", [true] = "On" },
																					},
																	spacer3 =		{
																						order = 2,
																						type = "header"
																					},
																	contextOffAlpha = {
																						order = 2,
																						name = "Overall Transparency",
																						type = "range",
																						desc = "Sets the HUD transparency when Context-sensitive fade is off",
																						hidden = function() return SilHUD2Settings.toggles.contextOn end,
																						get = function() return SilHUD2MasterFrame:GetAlpha() end,
																						set = 	function (v) 
																									SilHUD2Settings.alphas.globalAlpha = v;
																									SilHUD2:Transparency();
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						min = 0,
																						max = 1,
																						step = 0.05,
																						isPercent = true
																					  },
																	contextOnHigh = {
																						order = 3,
																						name = "Maximum Visibility",
																						type = "range",
																						desc = "Sets the HUD transparency when in combat",
																						hidden = function() return not SilHUD2Settings.toggles.contextOn end,
																						get = function() return SilHUD2Settings.alphas.highAlpha end,
																						set = 	function (v) 
																									SilHUD2Settings.alphas.highAlpha = v;
																									SilHUD2:Transparency();
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						min = 0,
																						max = 1,
																						step = 0.05,
																						isPercent = true
																					},
																	contextOnMid = {
																						order = 3,
																						name = "Medium Visibility",
																						type = "range",
																						desc = "Sets the HUD transparency when debuffed or targeting",
																						hidden = function() return not SilHUD2Settings.toggles.contextOn end,
																						get = function() return SilHUD2Settings.alphas.midAlpha end,
																						set = 	function (v) 
																									SilHUD2Settings.alphas.midAlpha = v;
																									SilHUD2:Transparency();
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						min = 0,
																						max = 1,
																						step = 0.05,
																						isPercent = true
																					},
																	contextOnLow = {
																						order = 3,
																						name = "Minimum Visibility",
																						type = "range",
																						desc = "Sets the minimum HUD transparency",
																						hidden = function() return not SilHUD2Settings.toggles.contextOn end,
																						get = function() return SilHUD2Settings.alphas.lowAlpha end,
																						set = 	function (v) 
																									SilHUD2Settings.alphas.lowAlpha = v;
																									SilHUD2:Transparency();
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						min = 0,
																						max = 1,
																						step = 0.05,
																						isPercent = true
																					}
																}
													},
									dimensions =	{
														order = 1,
														name = "Dimensions/Location",
														type = "group",
														desc = "Lock/Unlock the HUD frame for movement, resize the HUD",
														args =	{
																	width = {
																				order = 4,
																				name = "HUD Width",
																				type = "range",
																				desc = "Alters the width of the HUD",
																				disabled = function() return SH2ISLOCKED end,
																				get = function() return SilHUD2MasterFrame:GetWidth() end,
																				set = 	function (v) 
																							SilHUD2MasterFrame:SetWidth(v); 
																							SilHUD2Settings.master.width = v;
																							SilHUD2DBPC = SilHUD2Settings;
																						end,
																				min = 100,
																				max = 1000,
																				step = 5
																			},
																	height ={
																				order = 3,
																				name = "HUD Height",
																				type = "range",
																				desc = "Alters the width of the HUD",
																				disabled = function() return SH2ISLOCKED end,
																				get = function() return SilHUD2MasterFrame:GetHeight() end,
																				set = 	function (v) 
																							SilHUD2MasterFrame:SetHeight(v); 
																							SilHUD2Settings.master.height = v;
																							SilHUD2:UpdateFrameHeights();
																							SilHUD2DBPC = SilHUD2Settings;
																						end,
																				min = 100,
																				max = 1000,
																				step = 5
																			},
																	lock =	{
																				order = 1,
																				name = "Lock/Unlock",
																				type = "toggle",
																				desc = "Locks/Unlocks the HUD for movement",
																				get = function() return SH2ISLOCKED end,
																				set = 	function() 
																							local relativeTo;
																							SH2ISLOCKED = not SH2ISLOCKED; 
																							SilHUD2:Lock()
																							if SH2ISLOCKED then
																								SilHUD2Settings.master.myPoint, relativeTo, SilHUD2Settings.master.parPoint, SilHUD2Settings.master.offX, SilHUD2Settings.master.offY = SilHUD2MasterFrame:GetPoint();
																								SilHUD2Settings.master.parent = "UIParent";
																							end
																							SilHUD2DBPC = SilHUD2Settings;
																						end,
																				map = { [false] = "Unlocked", [true] = "Locked" },
																			},
																	spacer2 ={
																				order = 2,
																				type = "header"
																			}
																}
													},
									colors =		{
														order = 3,
														name = "Colors",
														type = "group",
														desc = "Customize SilHUD2's colors",
														args =	{
																	modAllColors =	{
																						order = 1,
																						name = "Match all Colors",
																						type = "toggle",
																						desc = "Enable to color entire HUD\nDisable to customize each element",
																						get = function() return SilHUD2Settings.toggles.allColors end,
																						set = 	function()	
																									SilHUD2Settings.toggles.allColors =  not SilHUD2Settings.toggles.allColors;  
																									SilHUD2Settings.toggles.matchBlizz = false;
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						map = { [false] = "Custom",  [true] = "Match All" }
																					},
																	warnings = 		{
																						order = 2,
																						name = "Low Health/Mana Warning",
																						type = "toggle",
																						desc = "Toggle low health and low mana warnings and colors on and off",
																						get =  	function() return SilHUD2Settings.toggles.warnings end,
																						set =	function()
																									SilHUD2Settings.toggles.warnings = not SilHUD2Settings.toggles.warnings;
																									SilHUD2DBPC = SilHUD2Settings;
																								end,
																						map = { [false] = "Off", [true] = "On" }
																					},
																	spacer5 = 		{
																						order = 3,
																						name = " ",
																						type = "header"
																					},
																	hudColor = 		{
																						order = 4,
																						name = "HUD Color",
																						type = "color",
																						desc = "Set HUD color",
																						hidden = function() return not SilHUD2Settings.toggles.allColors end,
																						get = function() return SilHUD2Settings.colors.plHealth.R, SilHUD2Settings.colors.plHealth.G, SilHUD2Settings.colors.plHealth.B, 1 end,
																						set = 	function (r, g, b, a)
																									for k, v in pairs(SilHUD2Settings.colors) do
																										SilHUD2Settings.colors[k] = { R = r, G = g, B = b};
																									end
																									SilHUD2DBPC = SilHUD2Settings;
																									SilHUD2:ColorStuff(true);
																								end
																					},
																	playerbars = 	{					
																						order = 5,
																						name = "Player",
																						type = "group",
																						desc = "Color the player's bars",
																						hidden = function() return SilHUD2Settings.toggles.allColors end,
																						args = 	{
																									plHealthBar = 	{
																														order = 1,
																														name = "Health Bar",
																														type = "color",
																														desc = "Player health bar color",
																														get = 	function()
																																	return SilHUD2Settings.colors.plHealth.R, SilHUD2Settings.colors.plHealth.G, SilHUD2Settings.colors.plHealth.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.plHealth.R = r;
																																	SilHUD2Settings.colors.plHealth.G = g;
																																	SilHUD2Settings.colors.plHealth.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									plPowerBar =		{
																														order = 2,
																														name = "Power Bar",
																														type = "color",
																														desc = "Player Power bar color",
																														get = 	function()
																																	return SilHUD2Settings.colors.plPower.R, SilHUD2Settings.colors.plPower.G, SilHUD2Settings.colors.plPower.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.plPower.R = r;
																																	SilHUD2Settings.colors.plPower.G = g;
																																	SilHUD2Settings.colors.plPower.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									plHealthScaleBar = {
																														order = 3,
																														name = "Health Scale",
																														type = "color",
																														desc = "Player health scale color",
																														get = 	function()
																																	return SilHUD2Settings.colors.plHealthScale.R, SilHUD2Settings.colors.plHealthScale.G, SilHUD2Settings.colors.plHealthScale.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.plHealthScale.R = r;
																																	SilHUD2Settings.colors.plHealthScale.G = g;
																																	SilHUD2Settings.colors.plHealthScale.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									plPowerScaleBar = {
																														order = 4,
																														name = "Power Scale",
																														type = "color",
																														desc = "Player power scale and Combo Counter color",
																														get = 	function()
																																	return SilHUD2Settings.colors.plPowerScale.R, SilHUD2Settings.colors.plPowerScale.G, SilHUD2Settings.colors.plPowerScale.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.plPowerScale.R = r;
																																	SilHUD2Settings.colors.plPowerScale.G = g;
																																	SilHUD2Settings.colors.plPowerScale.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									comboCounter =	{
																														order = 5,
																														name = "Combo Counter",
																														type = "color",
																														desc = "Combo counter color (rogues/druids)",
																														hidden = 	function()
																																		local localclass, englishClass = UnitClass("player");
																																		if englishClass == "ROGUE" or englishClass == "DRUID" then
																																			return false;
																																		else
																																			return true;
																																		end
																																	end,
																														get = 		function() 
																																		return SilHUD2Settings.colors.comboFrame.R, SilHUD2Settings.colors.comboFrame.G, SilHUD2Settings.colors.comboFrame.B; 
																																	end,
																														set =		function(r, g, b, a)
																																		SilHUD2Settings.colors.comboFrame.R = r;
																																		SilHUD2Settings.colors.comboFrame.G = g;
																																		SilHUD2Settings.colors.comboFrame.B = b;
																																		SilHUD2DBPC = SilHUD2Settings;
																																		SilHUD2:ColorStuff(true);
																																	end
																													},
																									plIndicators =	{
																														order = 6,
																														name = "Indicator Panel",
																														type = "color",
																														desc = "PVP/AFK/DND Indicator",
																														get = 		function() 
																																		return SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B; 
																																	end,
																														set = 		function(r, g, b, a)
																																		SilHUD2Settings.colors.indicatorPanel.R = r;
																																		SilHUD2Settings.colors.indicatorPanel.G = g;
																																		SilHUD2Settings.colors.indicatorPanel.B = b;
																																		SilHUD2DBPC = SilHUD2Settings;
																																		SilHUD2:ColorStuff(true);
																																	end
																													}
																								}
																					},
																	petbars = 	{					
																						order = 6,
																						name = "Pet",
																						type = "group",
																						desc = "Color the pet's bars",
																						hidden = function() return SilHUD2Settings.toggles.allColors end,
																						args = 	{
																									petHealthBar = 	{
																														order = 1,
																														name = "Health Bar",
																														type = "color",
																														desc = "Pet health bar color",
																														get = 	function()
																																	return SilHUD2Settings.colors.petHealth.R, SilHUD2Settings.colors.petHealth.G, SilHUD2Settings.colors.petHealth.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.petHealth.R = r;
																																	SilHUD2Settings.colors.petHealth.G = g;
																																	SilHUD2Settings.colors.petHealth.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									petPowerBar =		{
																														order = 2,
																														name = "Power Bar",
																														type = "color",
																														desc = "Pet Power bar color",
																														get = 	function()
																																	return SilHUD2Settings.colors.petPower.R, SilHUD2Settings.colors.petPower.G, SilHUD2Settings.colors.petPower.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.petPower.R = r;
																																	SilHUD2Settings.colors.petPower.G = g;
																																	SilHUD2Settings.colors.petPower.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									petHealthScaleBar = {
																														order = 3,
																														name = "Scale",
																														type = "color",
																														desc = "Pet health scale color",
																														get = 	function()
																																	return SilHUD2Settings.colors.petHealthScale.R, SilHUD2Settings.colors.petHealthScale.G, SilHUD2Settings.colors.petHealthScale.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.petHealthScale.R = r;
																																	SilHUD2Settings.colors.petHealthScale.G = g;
																																	SilHUD2Settings.colors.petHealthScale.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													}
																								}
																					},
																	tarbars = 	{					
																						order = 7,
																						name = "Target",
																						type = "group",
																						desc = "Color the target's bars",
																						hidden = function() return SilHUD2Settings.toggles.allColors end,
																						args = 	{	
																									tarHealthBar = 	{
																														order = 1,
																														name = "Health Bar",
																														type = "color",
																														desc = "Target health bar color",
																														get = 	function()
																																	return SilHUD2Settings.colors.tarHealth.R, SilHUD2Settings.colors.tarHealth.G, SilHUD2Settings.colors.tarHealth.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.tarHealth.R = r;
																																	SilHUD2Settings.colors.tarHealth.G = g;
																																	SilHUD2Settings.colors.tarHealth.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									matchBlizz =	{
																														order = 2,
																														name = "Auto Power colors",
																														type = "toggle",
																														desc = "Automatically match Blizzard's default power colors for your target",
																														get = function() return SilHUD2Settings.toggles.matchBlizz end,
																														set = 	function() 
																																	SilHUD2Settings.toggles.matchBlizz = not SilHUD2Settings.toggles.matchBlizz; 
																																	SilHUD2DBPC = SilHUD2Settings; 
																																	SilHUD2:ColorStuff(true) 
																																end,
																														map = { [false] = "Off", [true] = "On" }
																													},																														
																									tarPowerBar =	{
																														order = 3,
																														name = "Power Bar",
																														type = "color",
																														desc = "Target Power bar color",
																														disabled = function() return SilHUD2Settings.toggles.matchBlizz end,
																														get = 	function()
																																	return SilHUD2Settings.colors.tarPower.R, SilHUD2Settings.colors.tarPower.G, SilHUD2Settings.colors.tarPower.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.tarPower.R = r;
																																	SilHUD2Settings.colors.tarPower.G = g;
																																	SilHUD2Settings.colors.tarPower.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													},
																									tarHealthScaleBar = {
																														order = 4,
																														name = "Scale",
																														type = "color",
																														desc = "Target health scale color",
																														get = 	function()
																																	return SilHUD2Settings.colors.tarHealthScale.R, SilHUD2Settings.colors.tarHealthScale.G, SilHUD2Settings.colors.tarHealthScale.B;
																																end,
																														set =	function(r, g, b, a)
																																	SilHUD2Settings.colors.tarHealthScale.R = r;
																																	SilHUD2Settings.colors.tarHealthScale.G = g;
																																	SilHUD2Settings.colors.tarHealthScale.B = b;
																																	SilHUD2DBPC = SilHUD2Settings;
																																	SilHUD2:ColorStuff(true);
																																end
																													}
																								}
																					},
																	spacer4 = 		{
																						order = 9,
																						name = "   --------------   ",
																						type = "header"
																					},
																	resetColors = 	{
																						order = 10,
																						name = "Reset colors to default",
																						type = "execute",
																						desc = "Resets the HUD to the default color scheme",
																						func = 	function()
																									SilHUD2Settings.colors = SilHUD2Defaults.colors;
																									SilHUD2:ColorStuff(true);
																								end
																					}
																}
													},																												
									spacer1 = 		{
														order = 9,
														name = "   --------------   ",
														type = "header",
													},
									debugger1 =		{
														order = 10,
														name = "Debug SilHUD2Settings",
														type = "execute",
														desc = "Contents of SilHUD2Settings",
														hidden = function() local enabled = not SilHUD2Settings.toggles.sh2debug; return enabled end,
														func = 	function()
																	local category, data, value;
																	for category, data in pairs(SilHUD2Settings) do
																		for data, value in pairs(SilHUD2Settings[category]) do
																			self:Print("S " .. tostring(category) .. " " .. tostring(data) .. " " ..tostring(value));
																		end
																	end
																end
													},
									debugger2 =		{
														order = 11,
														name = "Debug SilHUD2Defaults",
														type = "execute",
														desc = "Contents of SilHUD2Defaults",
														hidden = function() local enabled = not SilHUD2Settings.toggles.sh2debug; return enabled end,
														func = 	function()
																	local category, data, value;
																	for category, data in pairs(SilHUD2Defaults) do
																		for data, value in pairs(SilHUD2Defaults[category]) do
																			self:Print("D " .. tostring(category) .. " " .. tostring(data) .. " " ..tostring(value));
																		end
																	end
																end
													},
									reset = 		{
														order = 12,
														name = "Reset to Defaults",
														type = "execute",
														desc = "Resets SilHUD2 to default settings",
														func = function () SilHUD2Settings = SilHUD2Defaults; SilHUD2DBPC = SilHUD2Settings; SilHUD2:Init(true) end,
													}
								}
					}
end